'use strict';

var path = require('path');
var through2 = require('through2');

module.exports = function (options) {
  options = options || {};
  var reactTools
  if (options.reactTools) {
    reactTools = options.reactTools;
  } else {
    reactTools = require('react-tools');
  }

  function compile(file, enc, callback) {
    if (file.isNull()) return callback(null, file);
    if (file.isStream()) return callback(new Error('Streams are not supported!'));
    var data = file.contents.toString(enc);
    try {
      var transformed = reactTools.transform(data, options.transformOptions);
      file.contents = new Buffer(transformed, enc);
      this.push(file);
      callback();
    } catch (error) {
      error.name = 'JsxError';
      error.message = file.path + ': ' + error.message;
      error.fileName = file.path;
      callback(error);
    }
  }

  return through2.obj(compile);
};
